/*
 * LockTestBean.java
 *
 * Created on 30 May 2007, 09:19
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ejb;

import entity.Entity;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author lister
 */
@Stateless
// Uncomment this out if using BEAN Managed Transaction
//@TransactionManagement(value=TransactionManagementType.BEAN)
public class LockTestBean implements LockTestRemote {
	
	@PersistenceContext
	EntityManager em;
	
	/** Creates a new instance of LockTestBean */
	public LockTestBean() {
	}

// Comment this out if using BEAN Managed Transaction
	@TransactionAttribute(value=TransactionAttributeType.REQUIRES_NEW)
	public int test() {
		// This should lock the row until the transaction is commited
		Entity e=null;
		
// Uncomment to force a transaction to start
//		e=em.find(Entity.class, 3);
//		e.setData((int)(System.currentTimeMillis()%10000);
//		em.flush();
		
		try {
			e=(Entity)em.createNamedQuery("Entity.getNext").setHint("toplink.pessimistic-lock", "Lock").setParameter("data",1).setMaxResults(1).getSingleResult();
			e.setData(2);	// change it so that we get a different one on the next query
		} catch (NoResultException ex) {
			return -1;
		}
		try {
			Thread.sleep(3000);
		} catch (InterruptedException ex) {
			ex.printStackTrace();
		}
		return e.getID();
	}
	

//////////////////////////////////////////////////////
// Uncomment this to test BEAN managed transactions
//////////////////////////////////////////////////////
//	@Resource
//	UserTransaction trans;
// 
//	public int test() {
//		Entity e=null;
//		trans.begin();
//
// Uncomment to force a transaction to start
//		e=em.find(Entity.class, 3);
//		e.setData((int)(System.currentTimeMillis()%10000);
//		em.flush();
//
//		try {
//			// This should lock the row until the transaction is commited
//			e=(Entity)em.createNamedQuery("Entity.getNext").setHint("toplink.pessimistic-lock", "Lock").setParameter("data",1).setMaxResults(1).getSingleResult();
//			e.setData(2);	// change it so that we get a different one on the next query
//		} catch (NoResultException ex{
//			return -1;
//		}
//		try {
//			Thread.sleep(3000); // wait to allow the other thread to run the query
//		} catch (InterruptedException ex) {
//			ex.printStackTrace();
//		}
//		trans.commit();
//		return e.getID();
//	}	


	
	public void createRows() {
		Entity e0=new Entity(1,1);
		em.persist(e0);
		Entity e1=new Entity(2,1);
		em.persist(e1);
		Entity e2=new Entity(3,1);
		em.persist(e2);
	}
	
	
}
