/*
 * Entity.java
 *
 * Created on 30 May 2007, 09:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package entity;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;

/**
 * Entity class Entity
 * 
 * @author lister
 */
@javax.persistence.Entity
@NamedQuery(name = "Entity.getNext", query = "SELECT e FROM Entity e WHERE e.data= :data")
public class Entity implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private int id;
	
	@Column(name="data")
	private int data;
	
	/** Creates a new instance of Entity */
	public Entity() {
	}

	/** Creates a new instance of Entity */
	public Entity(int id, int data) {
		this.id=id;
		this.data=data;
	}
	
	
	/**
	 * Gets the id of this Entity.
	 * @return the id
	 */
	public int getID() {
		return this.id;
	}

	/**
	 * Gets the id of this Entity.
	 * @return the id
	 */
	public int getData() {
		return this.data;
	}

	/**
	 * Sets the id of this Entity to the specified value.
	 * @param id the new id
	 */
	public void setData(int data) {
		this.data = data;
	}

	
	/**
	 * Returns a hash code value for the object.  This implementation computes 
	 * a hash code value based on the id fields in this object.
	 * @return a hash code value for this object.
	 */
	@Override
	public int hashCode() {
		return id;
	}

	/**
	 * Determines whether another object is equal to this Entity.  The result is 
	 * <code>true</code> if and only if the argument is not null and is a Entity object that 
	 * has the same id field values as this object.
	 * @param object the reference object with which to compare
	 * @return <code>true</code> if this object is the same as the argument;
	 * <code>false</code> otherwise.
	 */
	@Override
	public boolean equals(Object object) {
		// TODO: Warning - this method won't work in the case the id fields are not set
		if (!(object instanceof Entity)) {
			return false;
		}
		Entity other = (Entity)object;
		if (this.id != other.id) return false;
		return true;
	}

	/**
	 * Returns a string representation of the object.  This implementation constructs 
	 * that representation based on the id fields.
	 * @return a string representation of the object.
	 */
	@Override
	public String toString() {
		return "entity.Entity[id=" + id + "]";
	}
	
}
