/*
 * LockTestRemoteTest.java
 * JUnit based test
 *
 * Created on 30 May 2007, 09:59
 */

package ejb;

import javax.naming.InitialContext;
import junit.framework.*;

/**
 *
 * @author lister
 */
public class LockTestRemoteTest extends TestCase {
		
	ejb.LockTestRemote bean;
	
	public LockTestRemoteTest(String testName) {
		super(testName);
	}

	protected void setUp() throws Exception {
		InitialContext ctx=new InitialContext();
		bean=(ejb.LockTestRemote)ctx.lookup(ejb.LockTestRemote.class.getName());
		bean.createRows();
	}

	protected void tearDown() throws Exception {
	}

	
	private class MyThread implements Runnable {
		public int result=-1;
		LockTestRemote tr;
		int threadNo;
		public MyThread(LockTestRemote tr, int threadNo){
			this.tr=tr;
			this.threadNo=threadNo;
		}
		public void run(){
			result=tr.test();
		}
	}
	
	/**
	 * Test of testWithContainer method, of class ejb.LockTestRemote.
	 */
	public void testBean() {
		System.out.println("testing Bean");
		
		ThreadGroup tg=new ThreadGroup("testThreads");
		MyThread mt0=new MyThread(bean, 0);
		MyThread mt1=new MyThread(bean, 1);
		Thread t0=new Thread(tg, mt0);
		Thread t1=new Thread(tg, mt1);

		t0.start();
		t1.start();
		
		while (tg.activeCount()>0)
			try {
				Thread.sleep(500);
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}
			
		assertTrue("Didn't return different results", mt0.result!=mt1.result);
	}
	
}
